<?php

namespace BitGoblin\MCST\Minecraft;

class ServerConfig {

  // path to the server.properties file
  protected string $propertiesFile;
  // loaded properties
  protected array $config;

  public function __construct($propertiesFile) {
    $this->propertiesFile = $propertiesFile; // save the properties file
    $this->config = array(); // initialize array

    // parse config file
    $fh = fopen($propertiesFile, 'r+');
    while (!feof($fh)) {
      $line = fgets($fh);
      $eqpos = strpos($line, '=');
      $parameterName = substr($line, 0, $eqpos);
      $parameterValue = trim(substr($line, ($eqpos + 1)));

      // assign parameter values to the config array
      $this->config[$parameterName] = $parameterValue;
    }
  }

  public function get(string $param) {
    return $this->config[$param];
  }

  public function update(string $paramName, $paramValue) {
    // update the local variable value
    $this->config[$paramName] = $paramValue;

    // update and save the server.properties file
    $newFileContent = '';
    $fh = fopen($this->propertiesFile, 'r+');
    while (!feof($fh)) {
      $line = fgets($fh);

      if (!str_starts_with($line, '#')) {
        $eqpos = strpos($line, '=');
        $parameterName = substr($line, 0, $eqpos);
        $parameterValue = substr($line, ($eqpos + 1));

        // use the new value if it's being updated
        if ($parameterName == $paramName) {
          $parameterValue = $paramValue . "\n";
        }

        $newFileContent .= $parameterName . '=' . $parameterValue;
      } else {
        $newFileContent .= $line;
      }
    }

    // save the new properties file
    file_put_contents($this->propertiesFile, $newFileContent);
    fclose($fh);
  }

}
